Subject: Re: bug#64270: 30.0.50; Font update for no toolkit menu

From: Manuel Giraud <[email-masked]>
Date: Tue, 27 Jun 2023 16:13:15 +0200

Eli Zaretskii <[email-masked]> writes:

>> From: Manuel Giraud <[email-masked]>
>> Cc: [email-masked]
>> Date: Tue, 27 Jun 2023 09:04:51 +0200
>> 
>> Eli Zaretskii <[email-masked]> writes:
>> 
>> >> Date: Sat, 24 Jun 2023 19:00:04 +0200
>> >> From:  Manuel Giraud via "Bug reports for GNU Emacs,
>> >>  the Swiss army knife of text editors" <[email-masked]>
>> >> 
>> >> I'd like to be able to update the menu font (for the no toolkit build)
>> >> at runtime.  For this, my idea was to pass the font (from say the menu
>> >> face) to the XMenuCreate call in x_menu_show.
>> >
>> > Doesn' paneFont X resource already allow that?
>> 
>> Yes it does and I'm using it.  What I'm trying to achieve here is to be
>> able to change those menu face dynamically: if a user changes the main
>> frame font with 'set-frame-font', the menu font is also changed.
>
> Do you mean that the menu font will change to the same font as the
> frame's default face?  If so, I'm not sure that's a good idea: menu
> fonts are normally different from the default font, and in particular
> menus look nicer with variable-pitch fonts, whereas the default face
> should preferably use a fixed-pitch font.
>
> If this is not what you meant, then how would Emacs know which font to
> select for menus when the default face's font is changed?

For my usage, I imagine that yes the menu font would change when I
change the frame's default face.  But this because my menu face is
already derived from the default face.

For the general usage, my idea (and what I start doing in my patch, see
my first message) is to query the MENU_FACE_ID.  So the font into the
menus would change if the user modify its menu face.
-- 
Manuel Giraud